;    

IFNDEF INTERFACE_INC
INTERFACE_INC EQU <1>

; 
CLASS   CObject
CMETHOD  Create			:PTRPROTOARG	=ptrCreateObject		;; Constructor
CMETHOD  GetInitInstanceTable	:PTRPROTOARG	=ptrGetInitInstanceTable	;; Class Function
CMETHOD  GetInstanceSize	:PTRPROTOARG	=ptrGetInstanceSize	        ;; Class Function
CMETHOD  GetVirtualTable	:PTRPROTOARG	=ptrGetVirtualTable		;; Class Function
CMETHOD  GetVirtualTableSize	:PTRPROTOARG	=ptrGetVirtualTableSize		;; Class Function
CMETHOD  InitInstance		:PTRPROTO@4	=ptrInitInstance		;; VIRTUAL procedure
CMETHOD  Destroy		:PTRPROTO@4	=ptrDestroyObject		;; VIRTUAL Function
CMETHOD  Free			:PTRPROTO@4	=ptrFreeObject			;; Static Method
FIELD    vmtable		:DWORD	 	=0				;;    
ENDCLASS

; 
Interface  IUnknown, 	{00000000-0000-0000-C000000000000046}
    QueryInterface       PTRPROTO@12   ?      	
    AddRef               PTRPROTO@4    ?  	
    Release              PTRPROTO@4    ?
EndI

CLASS	CUnknown, CObject
OVERRID	InitInstance	:PTRPROTO@4	=ptrInitInstance_CUnknown
CMETHOD	QueryInterface	:PTRPROTO@12	=ptrQueryInterface	
CMETHOD	AddRef		:PTRPROTO@4	=ptrAddRef
CMETHOD	Release		:PTRPROTO@4	=ptrRelease
FIELD	FRefCount	:DWORD		= 1
ENDCLASS

; 
Interface IClassFactory,{00000001-0000-0000-C000000000000046}
    QueryInterface       PTRPROTO@12   ?      	
    AddRef               PTRPROTO@4    ?  	
    Release              PTRPROTO@4    ?
    CreateInstance	 PTRPROTO@16   ?
    LockServer		 PTRPROTO@8    ?
EndI       

ELSE
echo -----------------------------------------
echo WARNING Duplicate include file interface.inc
echo -----------------------------------------
ENDIF
